#ifndef VIEWER_H
#define VIEWER_H

#include <aabbox.h>
#include <QGLViewer/qglviewer.h>
#include <OpenMesh/Core/IO/MeshIO.hh>
#include <OpenMesh/Core/Mesh/Types/TriMesh_ArrayKernelT.hh>

typedef OpenMesh::TriMesh_ArrayKernelT<>  Mesh;

class Viewer : public QGLViewer
{
 public:
  Viewer(QWidget* parent=NULL);
  void loadModel(const char* fileName);
 protected:
  virtual void init();
  virtual void preDraw();
  virtual void draw();
  virtual void keyPressEvent(QKeyEvent* e);
 private:
  void renderModel() const;
  void renderSilhouettes() const;
  void renderShadowQuads() const;
  // Data for the model
  Mesh                         mesh;
  AABBox                       bbox;
  // Data for the light
  qglviewer::ManipulatedFrame* light;
  // Data for the interface
  bool                         showSilhouettes;
  bool                         showShadowQuads;
  bool                         showShadows;
};

#endif // VIEWER_H
